<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:gri="http://java.sun.com/jsf/composite/gri"
                xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns="http://www.w3.org/1999/xhtml">
    <h:form id="globalForm">

        #{epSOSXCACommonManager.init()}

        <h1>#{epSOSXCACommonManager.getTheNameOfThePage()}</h1>
        <s:div id="globalDiv">
            <gri:panel id="mainPanel">
                <f:facet name="header">#{epSOSXCACommonManager.getTheNameOfThePage()}</f:facet>
                <s:div>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.xdstar.ThisToolProvidesThePossibilityToCreateAValidRequ']} "/>
                    <h:outputText
                            value="#{epSOSXCACommonManager.selectedTransaction.keyword}"/>
                    <br/>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.xdstar.ToUseThisToolYouHaveTo']} "/>
                    <br/>
                    <ul>
                        <li>
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.xdstar.SelectYourResponderConfigurationOrAddANewOneOnTh']} "/>
                            <h:outputLink
                                    value="/XDStarClient/configuration/common/configurations.seam"
                                    title="#{messages['net.ihe.gazelle.xdstar.RespondersConfigurations']}">
                                #{messages['net.ihe.gazelle.xdstar.Configurations']}
                            </h:outputLink>
                            <h:outputText value=". "/>
                        </li>
                        <li>
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.xdstar.SelectTheMessageTypeYouWantToExecute']}"/>
                        </li>
                        <li>
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.xdstar.YouCanAddOptionalMethadatasByClickingOnTheButton']}"/>
                        </li>
                        <li>
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.xdstar.FulfilMetadatasOfTheRequest']} "/>
                        </li>
                        <li>
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.xdstar.ClickOnTheButtonexecuteToExecuteTheRequest']}"/>
                        </li>
                    </ul>
                </s:div>
                <ui:include src="/simu/header.xhtml">
                    <ui:param name="divToRerender"
                              value="messageConfigurationDiv,actionButtons,messagesDiv"/>
                    <ui:param name="simuManager" value="#{epSOSXCACommonManager}"/>
                    <ui:param name="diagramFile"
                              value="#{epSOSXCACommonManager.getTRansactionPictureName()}"/>
                    <ui:param name="sourceID"
                              value="#{epSOSXCACommonManager.getSourceOid()}"/>
                    <ui:param name="homeCommunityID"
                              value="#{epSOSXCACommonManager.gethomeCommunityId()}"/>
                    <ui:param name="simulatorConfigurationName"
                              value="#{messages['net.ihe.gazelle.xdstar.INITGatewaySimulator']}"/>
                    <ui:param name="displaySourceId" value="#{false}"/>
                    <ui:param name="displayhomeCommunityId" value="#{true}"/>
                </ui:include>
                <s:div id="messageConfigurationDiv">
                    <!-- MESSAGE TYPE -->
                    <s:div id="messageTypeDiv">
                        <div class="row">
                            <div class="col-md-3">
                                <s:decorate id="mtDecorate" template="/layout/form/_edit.xhtml"
                                            rendered="#{(epSOSXCACommonManager.selectedTransaction != null) and (epSOSXCACommonManager.selectedConfiguration != null)}">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.MessageType']}
                                    </ui:define>
                                    <h:selectOneMenu
                                            value="#{epSOSXCACommonManager.selectedMessageType}"
                                            styleClass="form-control gzl-form-control gzl-select-text">
                                        <s:selectItems
                                                value="#{epSOSXCACommonManager.getListOfMessageTypesForSelectedTransaction()}"
                                                var="mt" label="#{mt.displayAttributeName}"
                                                noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.PleaseSelect']}"/>
                                        <a4j:ajax event="change"
                                                  render="messageConfigurationDiv,actionButtons,messagesDiv"
                                                  listener="#{epSOSXCACommonManager.initAdhocQueryByMessageType()}"/>
                                        <s:convertEntity/>
                                    </h:selectOneMenu>
                                </s:decorate>
                            </div>
                        </div>
                    </s:div>
                    <s:div id="messageConfigurationDivR"
                           rendered="#{epSOSXCACommonManager.selectedMessageType != null}">
                        <s:div
                                rendered="#{not epSOSXCACommonManager.selectedMessageTypeIsRetrieve()}">
                            <f:subview id="subview_1">
                                <ui:include src="/rsqcommon/parameters.xhtml">
                                    <ui:param name="CommonAQManagerBean"
                                              value="#{epSOSXCACommonManager}"/>
                                </ui:include>
                            </f:subview>
                            <!-- RETURN TYPE -->
                            <s:div id="returnTypeDiv">
                                <div class="row">
                                    <div class="col-md-3">
                                        <s:decorate id="rtDecorate" template="/layout/form/_edit.xhtml"
                                                    rendered="#{epSOSXCACommonManager.selectedMessageType != null}">
                                            <ui:define name="label">#{messages['net.ihe.gazelle.xdstar.ReturnType']}
                                            </ui:define>
                                            <h:selectOneMenu
                                                    value="#{epSOSXCACommonManager.selectedReturnType}"
                                                    styleClass="form-control gzl-form-control gzl-select-text">
                                                <f:selectItems
                                                        value="#{epSOSXCACommonManager.getListOfReturnTypes()}"
                                                        var="rt" label="#{rt}"
                                                        noSelectionLabel="#{messages['net.ihe.gazelle.xdstar.PleaseSelect_2']}"/>
                                            </h:selectOneMenu>
                                        </s:decorate>
                                    </div>
                                </div>
                            </s:div>
                        </s:div>
                        <s:div id="messRetDiv"
                               rendered="#{epSOSXCACommonManager.selectedMessageTypeIsRetrieve()}">
                            #{epSOSXCACommonManager.initCommonRetrieve()}
                            <f:subview id="subview_2">
                                <ui:include src="/rdscommon/parameters.xhtml">
                                    <ui:param name="commonRDSManagerBean"
                                              value="#{epSOSXCACommonManager.commonRetrieve}"/>
                                    <ui:param name="isX" value="#{true}"/>
                                </ui:include>
                            </f:subview>
                        </s:div>
                        <!-- XUA -->
                        <f:subview id="subview_3">
                            <ui:include src="/simu/xua_with_trc.xhtml">
                                <ui:param name="simuManager" value="#{epSOSXCACommonManager}"/>
                            </ui:include>
                        </f:subview>
                    </s:div>
                </s:div>
                <!-- send button -->
                <s:div id="actionButtons">
                    <a4j:commandButton id="previewButton" styleClass="gzl-btn-blue"
                                       oncomplete="jq162('#previewMessagePanel').modal('show');"
                                       value="#{messages['net.ihe.gazelle.xdstar.Preview']}"
                                       rendered="#{epSOSXCACommonManager.selectedMessageType != null}"
                                       render="previewForm,previewMessagePanel"/>
                    <a4j:commandButton id="sendButton" styleClass="gzl-btn-green"
                                       actionListener="#{epSOSXCACommonManager.sendMessage()}"
                                       value="#{messages['gazelle.xca.initgw.Execute']}"
                                       rendered="#{epSOSXCACommonManager.selectedMessageType != null}"
                                       render="messagesDiv,messageDecoration,toptop"/>
                    <!-- reset button -->
                    <a4j:commandButton id="resetButton" styleClass="gzl-btn"
                                       actionListener="#{epSOSXCACommonManager.reset()}"
                                       value="#{messages['gazelle.xca.initgw.Reset']}" render="globalDiv"/>
                </s:div>
            </gri:panel>
            <!--  response div -->
            <s:div id="messagesDiv">
                <gri:panel id="messagesPanel"
                           rendered="#{epSOSXCACommonManager.displayResultPanel == true}">
                    <f:facet name="header">#{messages['gazelle.xca.initgw.ExecutionSummary']}</f:facet>
                    #{allMessageManagerBean.listMessagesToDisplay()}
                    <f:subview id="subview_4">
                        <ui:include id="messageTable" src="/messages/messageTable.xhtml">
                            <ui:param name="messageManagerBean"
                                      value="#{allMessageManagerBean}"/>
                        </ui:include>

                    </f:subview>
                    <br/>

                    <s:div>
                        #{allMessageManagerBean.initFirstMessage()}
                        <ui:include src="/rsqcommon/respViewer.xhtml">
                            <ui:param name="resp"
                                      value="#{allMessageManagerBean.selectedAdhocQueryResponseType}"/>
                        </ui:include>
                        <br/>
                    </s:div>
                </gri:panel>
            </s:div>
        </s:div>
    </h:form>
    <h:form id="previewForm">
        <gri:popupPanel id="previewMessagePanel" styleClass="modal-lg">
            <f:facet name="header">
                <h:outputText
                        value="#{messages['net.ihe.gazelle.xdstar.MessagePreview']}"/>
            </f:facet>
            <f:facet name="footer">
                <div align="right">
                    <a4j:commandButton styleClass="gzl-btn"
                                       value="#{messages['net.ihe.gazelle.xdstar.Cancel']}"
                                       onclick="jq162('#previewMessagePanel').modal('hide')"
                                       execute="@this"/>
                </div>
            </f:facet>
            <s:div id="previewMessagePanelDiv"
                   rendered="#{epSOSXCACommonManager.selectedMessageType != null}"
                   style="overflow: auto; width: 880px; height: 470px;">
                <gdk:insert id="highlightcontent"
                            content="#{epSOSXCACommonManager.previewMessage()}" highlight="xml"/>
            </s:div>
        </gri:popupPanel>
    </h:form>
    <f:subview id="subview_6">
        <ui:include src="/rsqcommon/aqmodalPanels.xhtml">
            <ui:param name="CommonAQManagerBean" value="#{epSOSXCACommonManager}"/>
        </ui:include>
    </f:subview>
</ui:composition>
